/*******************************************************************************
 * Copyright (c) 2015-2019 Skymind, Inc.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Apache License, Version 2.0 which is available at
 * https://www.apache.org/licenses/LICENSE-2.0.
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 *
 * SPDX-License-Identifier: Apache-2.0
 ******************************************************************************/

package org.deeplearning4j.ui.play.staticroutes;

import org.deeplearning4j.ui.i18n.I18NProvider;
import play.mvc.Result;

import java.util.function.BiFunction;

import static play.mvc.Results.ok;

/**
 * Route for multi-session internationalization setting
 *
 * @author Tamas Fenyvesi
 */
public class MultiSessionI18NRoute implements BiFunction<String, String, Result> {

    @Override
    public Result apply(String sessionId, String languageCode) {
        I18NProvider.getInstance(sessionId).setDefaultLanguage(languageCode);
        return ok();
    }
}
